﻿Imports System.Web.Script.Serialization
Imports System.Data
Imports System.Diagnostics

Partial Class _Default
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(sender As Object, e As System.EventArgs) Handles Me.Load
        If IsPostBack Then

            ' 引数の取得
            Dim passedArgument As String = Request.Params.[Get]("__EVENTARGUMENT")

            ' 引数を CellInfo オブジェクトに変換
            Dim jss As New JavaScriptSerializer()
            Dim ci As CellInfo = jss.Deserialize(Of CellInfo)(passedArgument)

            ' セル情報出力
            Debug.WriteLine("セル情報")
            Debug.WriteLine("行インデックス：" + ci.rowIndex)
            Debug.WriteLine("列インデックス：" + ci.columnIndex)
            Debug.WriteLine("セル値：" + ci.value)
            Debug.WriteLine("-------")
        Else
            Dim PrimaryColumn As DataColumn() = New DataColumn(0) {}
            Dim dt As New DataTable()
            PrimaryColumn(0) = dt.Columns.Add("ID", GetType(Integer))
            dt.Columns.Add("Name", GetType(String))
            dt.Columns.Add("Age", GetType(Integer))
            dt.Columns.Add("HomeTown", GetType(String))
            dt.Rows.Add(1, "たかし", 28, "静岡")
            dt.Rows.Add(2, "としひこ", 30, "大阪")
            dt.Rows.Add(3, "じゅんこ", 27, "鳥取")
            dt.Rows.Add(4, "さとみ", 28, "神奈川")
            dt.Rows.Add(5, "えりこ", 50, "東京")
            dt.Rows.Add(6, "しんいち", 32, "島根")
            dt.Rows.Add(7, "ゆみこ", 37, "静岡")
            dt.Rows.Add(8, "みな", 31, "兵庫")
            dt.Rows.Add(9, "たくや", 40, "徳島")
            dt.Rows.Add(10, "まゆ", 43, "三重")
            dt.PrimaryKey = PrimaryColumn
            Session("data") = dt
        End If
        Me.WebDataGrid1.DataSource = Session("data")
    End Sub
End Class

' セル情報クラス
Public Class CellInfo
    Public Property rowIndex() As String
        Get
            Return m_rowIndex
        End Get
        Set(value As String)
            m_rowIndex = value
        End Set
    End Property
    Private m_rowIndex As String
    Public Property columnIndex() As String
        Get
            Return m_columnIndex
        End Get
        Set(value As String)
            m_columnIndex = value
        End Set
    End Property
    Private m_columnIndex As String
    Public Property value() As String
        Get
            Return m_value
        End Get
        Set(value As String)
            m_value = value
        End Set
    End Property
    Private m_value As String
End Class